using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

using CMS.GlobalHelper;
using CMS.DataEngine;
using CMS.CMSHelper;
using CMS.UIControls;

public partial class CMSAdminControls_Debug_QueryLog : QueryLog
{
    protected string cmsVersion = null;
    protected double totalDuration = 0;
    protected int index = 0;


    protected void Page_Load(object sender, EventArgs e)
    {
        this.EnableViewState = false;
        this.Visible = true;
    }


    protected override void OnPreRender(EventArgs e)
    {
        base.OnPreRender(e);

        this.Visible = false;

        if (!DataHelper.DataSourceIsEmpty(this.QueryTable))
        {
            this.Visible = true;

            cmsVersion = ResHelper.GetString("Footer.Version") + "&nbsp;" + CMSContext.SYSTEM_VERSION + "&nbsp;" + ResHelper.GetString("Footer.Build") + "&nbsp;" + CMSContext.FullSystemVersion;

            gridQueries.Columns[1].HeaderText = ResHelper.GetString("QueryLog.QueryText");
            //gridQueries.Columns[2].HeaderText = ResHelper.GetString("QueryLog.QueryParameters");
            gridQueries.Columns[2].HeaderText = ResHelper.GetString("QueryLog.Context");
            gridQueries.Columns[3].HeaderText = ResHelper.GetString("QueryLog.QueryDuration");

            if (LogStyle != "")
            {
                this.ltlInfo.Text = "<div style=\"padding: 2px; font-weight: bold; background-color: #eecccc; border-bottom: solid 1px #ff0000;\">" + ResHelper.GetString("QueryLog.Info") + "</div>";
            }

            gridQueries.DataSource = this.QueryTable;
            gridQueries.DataBind();
        }
    }


    /// <summary>
    /// Gets the query duration
    /// </summary>
    protected string GetDuration(object startTime, object endTime)
    {
        DateTime start = ValidationHelper.GetDateTime(startTime, DateTimeHelper.ZERO_TIME);
        DateTime end = ValidationHelper.GetDateTime(endTime, DateTimeHelper.ZERO_TIME);

        if ((start == DateTimeHelper.ZERO_TIME) || (end == DateTimeHelper.ZERO_TIME) || (end < start))
        {
            return "N/A";
        }

        TimeSpan duration = end.Subtract(start);
        totalDuration += duration.TotalSeconds;

        return duration.TotalSeconds.ToString("F3");
    }


    protected int GetIndex()
    {
        return ++index;
    }
}
